



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Pandas快速入门（一）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Pandas快速入门（一）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-15 00:29:17 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>快速使用</h3>
<pre class="prettyprint linenums"><code>bogon:Documents rousseau$ ipython --pylab<br />
Python 3.6.0 (v3.6.0:41df79263a11, Dec 22 2016, 17:23:13)<br />
Type 'copyright', 'credits' or 'license' for more information<br />
IPython 6.2.1 -- An enhanced Interactive Python. Type '?' for help.<br />
Using matplotlib backend: MacOSX<br />
In [1]: import pandas as pd<br />
In [2]: import numpy as np<br />
In [3]: import matplotlib as plt<br />
In [4]: from pandas import Series, DataFrame<br />
</code></pre>
<p>按照Shell中的语句，就可以进入到Ipython的环境中使用Pandas分析数据，并绘制图表。ipython 环境的具体安装配置在Mac很简单，通过<strong>pip</strong>安装一下就可以，其他操作系统的安装可以自己百度一下。如果没有 ipython 也不要紧，标准的 python 命令行环境下也可以使用。</p>
<blockquote><p>如果你使用 ipython，通过TAB补齐和help功能能给你的工作带来很大的便利。</p></blockquote>
<h3>主要数据结构 Series 和 DataFrame 及创建</h3>
<p>Pandas里两个主要的数据结构就是 Series 和 DataFrame。Series 类似于Python的字典，DataFrame可以理解为二维表。</p>
<h4>Series</h4>
<p>可以通过传入一个List来创建一个Series对象。</p>
<pre class="prettyprint linenums"><code>In [6]: s = pd.Series([1,2,4,5,6,np.nan,7,8])

In [7]: s<br />
Out[7]:<br />
0    1.0<br />
1    2.0<br />
2    4.0<br />
3    5.0<br />
4    6.0<br />
5    NaN<br />
6    7.0<br />
7    8.0<br />
dtype: float64<br />
</code></pre>
<h4>DataFrame</h4>
<p>DataFrame 的创建有很多种方式，可以使用 numpy array 或者 Python的字典（包括嵌套字典）。</p>
<pre class="prettyprint linenums"><code>In [103]: dt = DataFrame({&quot;name&quot;:['wang','lv','bao','song'],&quot;sex&quot;:['male','female','male','female'],&quot;age&quot;:[12,23,35,47]})

In [104]: dt<br />
Out[104]:<br />
   age  name     sex<br />
0   12  wang    male<br />
1   23    lv  female<br />
2   35   bao    male<br />
3   47  song  female<br />
</code></pre>
<h3>查看、选择数据</h3>
<p>Series、DataFrame 查看数据的方式可以非常灵活，利用索引、切片，以及一些内置函数。</p>
<h4>查看索引，列</h4>
<p>接上面的例子</p>
<pre class="prettyprint linenums"><code>In [118]: dt.index<br />
Out[118]: RangeIndex(start=0, stop=4, step=1)

In [119]: dt.columns<br />
Out[119]: Index(['age', 'name', 'sex'], dtype='object')<br />
</code></pre>
<p>通过 <code>dt.values</code> 还可以查看底层的数据。</p>
<h4>选择查看部分数据</h4>
<p>Series和DataFrame可以快速的从整个结果集中选择你需要的数据，包括选择一列或几列、一行或几行，以及通过对值进行筛选选择对应结果集。推荐使用<code>.at、.iat、.loc、.iloc、.ix</code>进行选择。</p>
<p>1、获取某一列</p>
<pre class="prettyprint linenums"><code>In [140]: dt['name']<br />
Out[140]:<br />
序号<br />
0    wang<br />
1      lv<br />
2     bao<br />
3    song<br />
Name: name, dtype: object<br />
</code></pre>
<p>2、获取行，对行进行切片</p>
<pre class="prettyprint linenums"><code>In [143]: dt[1:3]<br />
Out[143]:<br />
    age name     sex<br />
序号<br />
1    23   lv  female<br />
2    35  bao    male<br />
</code></pre>
<p>3、通过loc选择一行或多行</p>
<pre class="prettyprint linenums"><code>In [162]: dt.loc[1]<br />
Out[162]:<br />
age         23<br />
name        lv<br />
sex     female<br />
Name: 1, dtype: object

In [163]: dt.loc[1:3]<br />
Out[163]:<br />
    age  name     sex<br />
序号<br />
1    23    lv  female<br />
2    35   bao    male<br />
3    47  song  female<br />
</code></pre>
<p>4、同时选择行和列</p>
<pre class="prettyprint linenums"><code>In [166]: dt.loc[2:3,['name','age']]<br />
Out[166]:<br />
    name  age<br />
序号<br />
2    bao   35<br />
3   song   47<br />
</code></pre>
<p>5、访问某个位置的值</p>
<pre class="prettyprint linenums"><code>In [168]: dt.at[1,'name']<br />
Out[168]: 'lv'<br />
</code></pre>
<p>以<code>i</code>开头的函数，表示通过具体的位置选择数据，而不是通过标签(即行名或列名)。</p>
<p>6、通过一个列中的值来选择数据</p>
<pre class="prettyprint linenums"><code>In [170]: dt[ dt.age &gt; 30 ]<br />
Out[170]:<br />
    age  name     sex<br />
序号<br />
2    35   bao    male<br />
3    47  song  female<br />
</code></pre>
<p>7、通过where来筛选数据</p>
<pre class="prettyprint linenums"><code>In [183]: dt[dt &gt; 30]<br />
Out[183]:<br />
     age  name     sex<br />
序号<br />
0    NaN  wang    male<br />
1    NaN    lv  female<br />
2   35.0   bao    male<br />
3   47.0  song  female<br />
</code></pre>
<h3>数据处理：转置、排序</h3>
<p>对于一个DataFrame，可以进行行列的转置，就像Excel中粘贴时交换x/y轴一样。</p>
<pre class="prettyprint linenums"><code>In [176]: df = DataFrame({&quot;beijing&quot;:{&quot;people&quot;:3000,&quot;area&quot;:5000,&quot;university&quot;:200},&quot;guangzhou&quot;:{&quot;people&quot;:2000,&quot;area&quot;:3000,&quot;university&quot;:150},&quot;shanghai&quot;:{&quot;peo<br />
     ...: ple&quot;:2800,&quot;area&quot;:2500,&quot;university&quot;:190}})

In [177]: df<br />
Out[177]:<br />
            beijing  guangzhou  shanghai<br />
area           5000       3000      2500<br />
people         3000       2000      2800<br />
university      200        150       190

In [178]: df.T<br />
Out[178]:<br />
           area  people  university<br />
beijing    5000    3000         200<br />
guangzhou  3000    2000         150<br />
shanghai   2500    2800         190<br />
</code></pre>
<p>从这个例子可以看出来，构建 DataFrame 对象时，可以采用层次化的 dict 。</p>
<p>排序操作，可以按照列或者行进行排序，非常灵活。</p>
<pre class="prettyprint linenums"><code>In [194]: df.sort_values(by='beijing')<br />
Out[194]:<br />
            beijing  guangzhou  shanghai<br />
university      200        150       190<br />
people         3000       2000      2800<br />
area           5000       3000      2500

In [195]: df.sort_values(by='beijing',ascending=False)<br />
Out[195]:<br />
            beijing  guangzhou  shanghai<br />
area           5000       3000      2500<br />
people         3000       2000      2800<br />
university      200        150       190

In [196]: df.sort_values(axis=1,by='people',ascending=False)<br />
Out[196]:<br />
            beijing  shanghai  guangzhou<br />
area           5000      2500       3000<br />
people         3000      2800       2000<br />
university      200       190        150<br />
</code></pre>
<h3>统计操作</h3>
<p><code>describe</code>可以对数据集进行快速的统计分析。</p>
<pre class="prettyprint linenums"><code>In [198]: df.T.describe()<br />
Out[198]:<br />
              area       people  university<br />
count     3.000000     3.000000    3.000000<br />
mean   3500.000000  2600.000000  180.000000<br />
std    1322.875656   529.150262   26.457513<br />
min    2500.000000  2000.000000  150.000000<br />
25%    2750.000000  2400.000000  170.000000<br />
50%    3000.000000  2800.000000  190.000000<br />
75%    4000.000000  2900.000000  195.000000<br />
max    5000.000000  3000.000000  200.000000<br />
</code></pre>
<p>参考资料：<br /><br />
1、<a href="http://pandas.pydata.org" rel="external nofollow noreferrer">pandas</a><br /><br />
2、<a href="https://www.cnblogs.com/chaosimple/p/4153083.html" rel="external nofollow noreferrer">十分钟搞定Pandas</a><br /><br />
3、<a href="" rel="external nofollow noreferrer">利用Python进行数据分析</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qx2xke8.html">关于Web报表FineReport打印的开发应用案例</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwge1l8.html">团队项目作业：利用NABCD模型进行竞争性需求分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96rn5j9.html">eclipse启动无响应，停留在Loading workbench状态，或老是加载不了revert resources</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdngdx9.html">mvc Areas注册域常见问题一</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m010jq.html">uva 11995 I Can Guess the Data Structure  stack&comma;queue&comma;priority&lowbar;queue</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnxk16q.html">java面板</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x07j09.html">常用的Linux操作命令（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdj33y9.html">XML wsdl soap xslt xsl ide</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kppl6j9.html">default argument given of parameter 的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd3eg49.html">FPGA两种寄存器的使能</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z36v39.html">Samba服务安装及配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy13nxjq.html">springmvc注解形式的开发参数接收</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z1klg9.html">关于USB驱动的软件测试方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zodo5dq.html">Linux自启动执行脚本方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv0zgz8.html">python 自动获取手机短信验证码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9605k2v9.html">linux 系统备份和恢复</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjk5z79.html">Erlang ETS Table</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllxl1kq.html">【API知识】MongoTemplate非映射方式操作Document</a>
		</li>
						<li><a href="https://www.batexi.com/a/9602z649.html">SpringMVC加载配置Properties文件的几种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvgdwk8.html">Jquery Validate 相关参数</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/ql1m4m19.html">工作流调度器azkaban2&period;5&period;0的安装和使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7em67j9.html">js数组去重与性能分析（时间复杂度很重要）</a>
			</li>
						<li><a href="https://www.batexi.com/a/953x4me8.html">html5 利用谷歌地图显示当前位置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvdm0jq.html">rabbitmq学习（五） &mdash;&mdash; 路由</a>
			</li>
						<li><a href="https://www.batexi.com/a/902voy3q.html">运行程序，解读this指向---case4</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ko1w77q.html">IE9中ajax请求成功后返回值却是undefined</a>
			</li>
						<li><a href="https://www.batexi.com/a/953x5k08.html">&lbrack;CEOI2017&rsqb;Palindromic Partitions</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kop0drq.html">&lbrack;Java&rsqb;JavaScript在这里学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2kwgd8.html">Xtreme8&period;0 - Play with GCD dp</a>
			</li>
						<li><a href="https://www.batexi.com/a/963pp049.html">div光标</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
